Index: XIOS/dev/dev_trunk_graph/src/interface/fortran/idata.F90
===================================================================
--- XIOS/dev/dev_trunk_graph/src/interface/fortran/idata.F90	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/interface/fortran/idata.F90	(revision 2137)
@@ -627,4 +1002,13 @@
    END SUBROUTINE xios(send_field_r4_3d)
 
+   SUBROUTINE  xios(send_field_r4_4d_hdl)(field_hdl, data4d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(IN) :: data4d_k4(:,:,:,:)
+      CALL cxios_write_data_k44_hdl(field_hdl%daddr, data4d_k4, &
+                                size(data4d_k4, 1), size(data4d_k4, 2), size(data4d_k4, 3), &
+                                size(data4d_k4, 4))
+   END SUBROUTINE  xios(send_field_r4_4d_hdl)
+   
    SUBROUTINE  xios(send_field_r4_4d)(fieldid, data4d_k4)
    IMPLICIT NONE
@@ -636,4 +1020,13 @@
    END SUBROUTINE  xios(send_field_r4_4d)
 
+   SUBROUTINE  xios(send_field_r4_5d_hdl)(field_hdl, data5d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(IN) :: data5d_k4(:,:,:,:,:)
+      CALL cxios_write_data_k45_hdl(field_hdl%daddr, data5d_k4, &
+                                size(data5d_k4, 1), size(data5d_k4, 2), size(data5d_k4, 3), &
+                                size(data5d_k4, 4), size(data5d_k4, 5))
+   END SUBROUTINE  xios(send_field_r4_5d_hdl)
+
    SUBROUTINE  xios(send_field_r4_5d)(fieldid, data5d_k4)
    IMPLICIT NONE
@@ -645,4 +1038,13 @@
    END SUBROUTINE  xios(send_field_r4_5d)
 
+   SUBROUTINE  xios(send_field_r4_6d_hdl)(field_hdl, data6d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(IN) :: data6d_k4(:,:,:,:,:,:)
+      CALL cxios_write_data_k46_hdl(field_hdl%daddr, data6d_k4, &
+                                size(data6d_k4, 1), size(data6d_k4, 2), size(data6d_k4, 3), &
+                                size(data6d_k4, 4), size(data6d_k4, 5), size(data6d_k4, 6))
+   END SUBROUTINE  xios(send_field_r4_6d_hdl)
+   
    SUBROUTINE  xios(send_field_r4_6d)(fieldid, data6d_k4)
    IMPLICIT NONE
@@ -654,4 +1056,14 @@
    END SUBROUTINE  xios(send_field_r4_6d)
 
+   SUBROUTINE  xios(send_field_r4_7d_hdl)(field_hdl, data7d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(IN) :: data7d_k4(:,:,:,:,:,:,:)
+      CALL cxios_write_data_k47_hdl(field_hdl%daddr, data7d_k4, &
+                                size(data7d_k4, 1), size(data7d_k4, 2), size(data7d_k4, 3), &
+                                size(data7d_k4, 4), size(data7d_k4, 5), size(data7d_k4, 6), &
+                                size(data7d_k4, 7))
+   END SUBROUTINE  xios(send_field_r4_7d_hdl)
+   
    SUBROUTINE  xios(send_field_r4_7d)(fieldid, data7d_k4)
    IMPLICIT NONE
@@ -665,4 +1077,11 @@
 
    ! Receive field functions
+   SUBROUTINE xios(recv_field_r8_0d_hdl)(field_hdl, data0d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8)              , INTENT(OUT):: data0d_k8
+      CALL cxios_read_data_k80_hdl(field_hdl%daddr, data0d_k8, 1)
+   END SUBROUTINE xios(recv_field_r8_0d_hdl)
+
    SUBROUTINE xios(recv_field_r8_0d)(fieldid, data0d_k8)
    IMPLICIT NONE
@@ -672,4 +1091,11 @@
    END SUBROUTINE xios(recv_field_r8_0d)
 
+   SUBROUTINE xios(recv_field_r8_1d_hdl)(field_hdl, data1d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8), DIMENSION(*), INTENT(OUT) :: data1d_k8(:)
+      CALL cxios_read_data_k81_hdl(field_hdl%daddr, data1d_k8, size(data1d_k8, 1))
+   END SUBROUTINE xios(recv_field_r8_1d_hdl)
+
    SUBROUTINE xios(recv_field_r8_1d)(fieldid, data1d_k8)
    IMPLICIT NONE
@@ -679,4 +1105,11 @@
    END SUBROUTINE xios(recv_field_r8_1d)
 
+   SUBROUTINE  xios(recv_field_r8_2d_hdl)(field_hdl, data2d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8), DIMENSION(*), INTENT(OUT) :: data2d_k8(:,:)
+      CALL cxios_read_data_k82_hdl(field_hdl%daddr, data2d_k8, size(data2d_k8, 1), size(data2d_k8, 2))
+   END SUBROUTINE  xios(recv_field_r8_2d_hdl)
+
    SUBROUTINE  xios(recv_field_r8_2d)(fieldid, data2d_k8)
    IMPLICIT NONE
@@ -686,4 +1119,11 @@
    END SUBROUTINE  xios(recv_field_r8_2d)
 
+   SUBROUTINE  xios(recv_field_r8_3d_hdl)(field_hdl, data3d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8), DIMENSION(*), INTENT(OUT) :: data3d_k8(:,:,:)
+      CALL cxios_read_data_k83_hdl(field_hdl%daddr, data3d_k8, size(data3d_k8, 1), size(data3d_k8, 2), size(data3d_k8, 3))
+   END SUBROUTINE  xios(recv_field_r8_3d_hdl)
+
    SUBROUTINE  xios(recv_field_r8_3d)(fieldid, data3d_k8)
    IMPLICIT NONE
@@ -692,4 +1132,13 @@
       CALL cxios_read_data_k83(fieldid, len(fieldid), data3d_k8, size(data3d_k8, 1), size(data3d_k8, 2), size(data3d_k8, 3))
    END SUBROUTINE  xios(recv_field_r8_3d)
+
+   SUBROUTINE  xios(recv_field_r8_4d_hdl)(field_hdl, data4d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8), DIMENSION(*), INTENT(OUT) :: data4d_k8(:,:,:,:)
+      CALL cxios_read_data_k84_hdl(field_hdl%daddr, data4d_k8, &
+                                size(data4d_k8, 1), size(data4d_k8, 2), size(data4d_k8, 3), &
+                                size(data4d_k8, 4))
+   END SUBROUTINE  xios(recv_field_r8_4d_hdl)
 
    SUBROUTINE  xios(recv_field_r8_4d)(fieldid, data4d_k8)
@@ -702,4 +1151,13 @@
    END SUBROUTINE  xios(recv_field_r8_4d)
 
+   SUBROUTINE  xios(recv_field_r8_5d_hdl)(field_hdl, data5d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8), DIMENSION(*), INTENT(OUT) :: data5d_k8(:,:,:,:,:)
+      CALL cxios_read_data_k85_hdl(field_hdl%daddr, data5d_k8, &
+                                size(data5d_k8, 1), size(data5d_k8, 2), size(data5d_k8, 3), &
+                                size(data5d_k8, 4), size(data5d_k8, 5))
+   END SUBROUTINE  xios(recv_field_r8_5d_hdl)
+
    SUBROUTINE  xios(recv_field_r8_5d)(fieldid, data5d_k8)
    IMPLICIT NONE
@@ -711,4 +1169,13 @@
    END SUBROUTINE  xios(recv_field_r8_5d)
 
+   SUBROUTINE  xios(recv_field_r8_6d_hdl)(field_hdl, data6d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8), DIMENSION(*), INTENT(OUT) :: data6d_k8(:,:,:,:,:,:)
+      CALL cxios_read_data_k86_hdl(field_hdl%daddr, data6d_k8, &
+                                size(data6d_k8, 1), size(data6d_k8, 2), size(data6d_k8, 3), &
+                                size(data6d_k8, 4), size(data6d_k8, 5), size(data6d_k8, 6))
+   END SUBROUTINE  xios(recv_field_r8_6d_hdl)
+
    SUBROUTINE  xios(recv_field_r8_6d)(fieldid, data6d_k8)
    IMPLICIT NONE
@@ -720,5 +1187,15 @@
    END SUBROUTINE  xios(recv_field_r8_6d)
 
-   SUBROUTINE  xios(recv_field_r8_7d)(fieldid, data7d_k8)
+  SUBROUTINE  xios(recv_field_r8_7d_hdl)(field_hdl, data7d_k8)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 8), DIMENSION(*), INTENT(OUT) :: data7d_k8(:,:,:,:,:,:,:)
+      CALL cxios_read_data_k87_hdl(field_hdl%daddr, data7d_k8, &
+                                size(data7d_k8, 1), size(data7d_k8, 2), size(data7d_k8, 3), &
+                                size(data7d_k8, 4), size(data7d_k8, 5), size(data7d_k8, 6), &
+                                size(data7d_k8, 7))
+   END SUBROUTINE  xios(recv_field_r8_7d_hdl)
+
+  SUBROUTINE  xios(recv_field_r8_7d)(fieldid, data7d_k8)
    IMPLICIT NONE
       CHARACTER(len = *)               , INTENT(IN) :: fieldid
@@ -730,4 +1207,11 @@
    END SUBROUTINE  xios(recv_field_r8_7d)
 
+   SUBROUTINE xios(recv_field_r4_0d_hdl)(field_hdl, data0d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4)              , INTENT(OUT):: data0d_k4
+      CALL cxios_read_data_k40_hdl(field_hdl%daddr, data0d_k4, 1)
+   END SUBROUTINE xios(recv_field_r4_0d_hdl)
+
    SUBROUTINE xios(recv_field_r4_0d)(fieldid, data0d_k4)
    IMPLICIT NONE
@@ -737,4 +1221,11 @@
    END SUBROUTINE xios(recv_field_r4_0d)
 
+   SUBROUTINE xios(recv_field_r4_1d_hdl)(field_hdl, data1d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(OUT) :: data1d_k4(:)
+      CALL cxios_read_data_k41_hdl(field_hdl%daddr, data1d_k4, size(data1d_k4, 1))
+   END SUBROUTINE xios(recv_field_r4_1d_hdl)
+
    SUBROUTINE xios(recv_field_r4_1d)(fieldid, data1d_k4)
    IMPLICIT NONE
@@ -744,4 +1235,11 @@
    END SUBROUTINE xios(recv_field_r4_1d)
 
+   SUBROUTINE xios(recv_field_r4_2d_hdl)(field_hdl, data2d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(OUT) :: data2d_k4(:,:)
+      CALL cxios_read_data_k42_hdl(field_hdl%daddr, data2d_k4, size(data2d_k4, 1), size(data2d_k4, 2))
+   END SUBROUTINE xios(recv_field_r4_2d_hdl)
+
    SUBROUTINE xios(recv_field_r4_2d)(fieldid, data2d_k4)
    IMPLICIT NONE
@@ -751,4 +1249,11 @@
    END SUBROUTINE xios(recv_field_r4_2d)
 
+   SUBROUTINE xios(recv_field_r4_3d_hdl)(field_hdl, data3d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(OUT) :: data3d_k4(:,:,:)
+      CALL cxios_read_data_k43_hdl(field_hdl%daddr, data3d_k4, size(data3d_k4, 1), size(data3d_k4, 2), size(data3d_k4, 3))
+   END SUBROUTINE xios(recv_field_r4_3d_hdl)
+
    SUBROUTINE xios(recv_field_r4_3d)(fieldid, data3d_k4)
    IMPLICIT NONE
@@ -757,4 +1262,13 @@
       CALL cxios_read_data_k43(fieldid, len(fieldid), data3d_k4, size(data3d_k4, 1), size(data3d_k4, 2), size(data3d_k4, 3))
    END SUBROUTINE xios(recv_field_r4_3d)
+
+   SUBROUTINE  xios(recv_field_r4_4d_hdl)(field_hdl, data4d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(OUT) :: data4d_k4(:,:,:,:)
+      CALL cxios_read_data_k44_hdl(field_hdl%daddr, data4d_k4, &
+                                size(data4d_k4, 1), size(data4d_k4, 2), size(data4d_k4, 3), &
+                                size(data4d_k4, 4))
+   END SUBROUTINE  xios(recv_field_r4_4d_hdl)
 
    SUBROUTINE  xios(recv_field_r4_4d)(fieldid, data4d_k4)
@@ -767,4 +1281,13 @@
    END SUBROUTINE  xios(recv_field_r4_4d)
 
+   SUBROUTINE  xios(recv_field_r4_5d_hdl)(field_hdl, data5d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(OUT) :: data5d_k4(:,:,:,:,:)
+      CALL cxios_read_data_k45_hdl(field_hdl%daddr, data5d_k4, &
+                                size(data5d_k4, 1), size(data5d_k4, 2), size(data5d_k4, 3), &
+                                size(data5d_k4, 4), size(data5d_k4, 5))
+   END SUBROUTINE  xios(recv_field_r4_5d_hdl)
+
    SUBROUTINE  xios(recv_field_r4_5d)(fieldid, data5d_k4)
    IMPLICIT NONE
@@ -776,4 +1299,13 @@
    END SUBROUTINE  xios(recv_field_r4_5d)
 
+   SUBROUTINE  xios(recv_field_r4_6d_hdl)(field_hdl, data6d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(OUT) :: data6d_k4(:,:,:,:,:,:)
+      CALL cxios_read_data_k46_hdl(field_hdl%daddr, data6d_k4, &
+                                size(data6d_k4, 1), size(data6d_k4, 2), size(data6d_k4, 3), &
+                                size(data6d_k4, 4), size(data6d_k4, 5), size(data6d_k4, 6))
+   END SUBROUTINE  xios(recv_field_r4_6d_hdl)
+
    SUBROUTINE  xios(recv_field_r4_6d)(fieldid, data6d_k4)
    IMPLICIT NONE
@@ -784,4 +1316,14 @@
                                 size(data6d_k4, 4), size(data6d_k4, 5), size(data6d_k4, 6))
    END SUBROUTINE  xios(recv_field_r4_6d)
+
+   SUBROUTINE  xios(recv_field_r4_7d_hdl)(field_hdl, data7d_k4)
+   IMPLICIT NONE
+      TYPE(txios(field))              :: field_hdl
+      REAL     (kind = 4), DIMENSION(*), INTENT(OUT) :: data7d_k4(:,:,:,:,:,:,:)
+      CALL cxios_read_data_k47_hdl(field_hdl%daddr, data7d_k4, &
+                                size(data7d_k4, 1), size(data7d_k4, 2), size(data7d_k4, 3), &
+                                size(data7d_k4, 4), size(data7d_k4, 5), size(data7d_k4, 6), &
+                                size(data7d_k4, 7))
+   END SUBROUTINE  xios(recv_field_r4_7d_hdl)
 
    SUBROUTINE  xios(recv_field_r4_7d)(fieldid, data7d_k4)
@@ -797,6 +1339,7 @@
    ! Get variable functions
    LOGICAL FUNCTION xios(getVar_k8)(varId, data_k8)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len = *)               , INTENT(IN) :: varId
       REAL     (kind = 8)              , INTENT(OUT):: data_k8
@@ -808,6 +1351,7 @@
 
    LOGICAL FUNCTION xios(getVar_k4)(varId, data_k4)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len = *)               , INTENT(IN) :: varId
       REAL     (kind = 4)              , INTENT(OUT):: data_k4
@@ -819,6 +1363,7 @@
 
    LOGICAL FUNCTION xios(getVar_int)(varId, data_int)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len = *)               , INTENT(IN) :: varId
       INTEGER                          , INTENT(OUT):: data_int
@@ -830,17 +1375,20 @@
 
    LOGICAL FUNCTION xios(getVar_logic)(varId, data_logic)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len  = *)              , INTENT(IN) :: varId
-      LOGICAL  (kind = 4)              , INTENT(OUT):: data_logic
-
-      CALL cxios_get_variable_data_logic(varId, len(varId), data_logic, val)
-
+      LOGICAL  ,INTENT(OUT)                         :: data_logic
+      LOGICAL (C_BOOL)                              :: data_tmp
+
+      CALL cxios_get_variable_data_logic(varId, len(varId), data_tmp, val)
       xios(getVar_logic) = val
+      IF (val) data_logic = data_tmp
    END FUNCTION xios(getVar_logic)
 
    LOGICAL FUNCTION xios(getVar_char)(varId, data_char)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len  = *)              , INTENT(IN) :: varId
       CHARACTER(len  = *)              , INTENT(OUT):: data_char
@@ -853,6 +1401,7 @@
    ! Set variable functions
    LOGICAL FUNCTION xios(setVar_k8)(varId, data_k8)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len = *)               , INTENT(IN) :: varId
       REAL     (kind = 8)              , INTENT(IN) :: data_k8
@@ -864,6 +1413,7 @@
 
    LOGICAL FUNCTION xios(setVar_k4)(varId, data_k4)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len = *)               , INTENT(IN) :: varId
       REAL     (kind = 4)              , INTENT(IN) :: data_k4
@@ -875,6 +1425,7 @@
 
    LOGICAL FUNCTION xios(setVar_int)(varId, data_int)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                           :: val
       CHARACTER(len = *)               , INTENT(IN) :: varId
       INTEGER                          , INTENT(IN) :: data_int
@@ -886,10 +1437,13 @@
 
    LOGICAL FUNCTION xios(setVar_logic)(varId, data_logic)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL(kind = C_BOOL)                        :: val
       CHARACTER(len  = *)              , INTENT(IN) :: varId
-      LOGICAL  (kind = 4)              , INTENT(IN) :: data_logic
-
-      CALL cxios_set_variable_data_logic(varId, len(varId), data_logic, val)
+      LOGICAL                          , INTENT(IN) :: data_logic
+      LOGICAL  (kind = C_BOOL)                      :: data_tmp
+
+      data_tmp = data_logic
+      CALL cxios_set_variable_data_logic(varId, len(varId), data_tmp, val)
 
       xios(setVar_logic) = val
@@ -897,6 +1451,7 @@
 
    LOGICAL FUNCTION xios(setVar_char)(varId, data_char)
-   IMPLICIT NONE
-      LOGICAL  (kind = 1)                           :: val
+   USE ISO_C_BINDING
+   IMPLICIT NONE
+      LOGICAL  (kind = C_BOOL)                      :: val
       CHARACTER(len  = *)              , INTENT(IN) :: varId
       CHARACTER(len  = *)              , INTENT(IN) :: data_char
Index: XIOS/dev/dev_trunk_graph/src/interface/fortran/ixios_interfaces.F90
===================================================================
--- XIOS/dev/dev_trunk_graph/src/interface/fortran/ixios_interfaces.F90	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/interface/fortran/ixios_interfaces.F90	(revision 2137)
@@ -11,8 +11,16 @@
                   xios(send_field_r4_0d), xios(send_field_r4_1d), xios(send_field_r4_2d), xios(send_field_r4_3d), &
                   xios(send_field_r4_4d), xios(send_field_r4_5d), xios(send_field_r4_6d), xios(send_field_r4_7d), &
+                  xios(send_field_r8_0d_hdl), xios(send_field_r8_1d_hdl), xios(send_field_r8_2d_hdl), xios(send_field_r8_3d_hdl), &
+                  xios(send_field_r8_4d_hdl), xios(send_field_r8_5d_hdl), xios(send_field_r8_6d_hdl), xios(send_field_r8_7d_hdl), &
+                  xios(send_field_r4_0d_hdl), xios(send_field_r4_1d_hdl), xios(send_field_r4_2d_hdl), xios(send_field_r4_3d_hdl), &
+                  xios(send_field_r4_4d_hdl), xios(send_field_r4_5d_hdl), xios(send_field_r4_6d_hdl), xios(send_field_r4_7d_hdl), &
                   xios(recv_field_r8_0d), xios(recv_field_r8_1d), xios(recv_field_r8_2d), xios(recv_field_r8_3d), &
                   xios(recv_field_r8_4d), xios(recv_field_r8_5d), xios(recv_field_r8_6d), xios(recv_field_r8_7d), &
                   xios(recv_field_r4_0d), xios(recv_field_r4_1d), xios(recv_field_r4_2d), xios(recv_field_r4_3d), &
                   xios(recv_field_r4_4d), xios(recv_field_r4_5d), xios(recv_field_r4_6d), xios(recv_field_r4_7d), &
+                  xios(recv_field_r8_0d_hdl), xios(recv_field_r8_1d_hdl), xios(recv_field_r8_2d_hdl), xios(recv_field_r8_3d_hdl), &
+                  xios(recv_field_r8_4d_hdl), xios(recv_field_r8_5d_hdl), xios(recv_field_r8_6d_hdl), xios(recv_field_r8_7d_hdl), &
+                  xios(recv_field_r4_0d_hdl), xios(recv_field_r4_1d_hdl), xios(recv_field_r4_2d_hdl), xios(recv_field_r4_3d_hdl), &
+                  xios(recv_field_r4_4d_hdl), xios(recv_field_r4_5d_hdl), xios(recv_field_r4_6d_hdl), xios(recv_field_r4_7d_hdl), &
                   xios(getVar_k8), xios(getVar_k4), xios(getVar_int), xios(getVar_logic), xios(getVar_char),      &
                   xios(setVar_k8), xios(setVar_k4), xios(setVar_int), xios(setVar_logic), xios(setVar_char)
@@ -239,5 +247,9 @@
                    xios(send_field_r8_4d), xios(send_field_r8_5d), xios(send_field_r8_6d), xios(send_field_r8_7d), &
                    xios(send_field_r4_0d), xios(send_field_r4_1d), xios(send_field_r4_2d), xios(send_field_r4_3d), &
-                   xios(send_field_r4_4d), xios(send_field_r4_5d), xios(send_field_r4_6d), xios(send_field_r4_7d)
+                   xios(send_field_r4_4d), xios(send_field_r4_5d), xios(send_field_r4_6d), xios(send_field_r4_7d), &
+                   xios(send_field_r8_0d_hdl), xios(send_field_r8_1d_hdl), xios(send_field_r8_2d_hdl), xios(send_field_r8_3d_hdl), &
+                   xios(send_field_r8_4d_hdl), xios(send_field_r8_5d_hdl), xios(send_field_r8_6d_hdl), xios(send_field_r8_7d_hdl), &
+                   xios(send_field_r4_0d_hdl), xios(send_field_r4_1d_hdl), xios(send_field_r4_2d_hdl), xios(send_field_r4_3d_hdl), &
+                   xios(send_field_r4_4d_hdl), xios(send_field_r4_5d_hdl), xios(send_field_r4_6d_hdl), xios(send_field_r4_7d_hdl)
 END INTERFACE xios(send_field)
 
@@ -246,5 +258,9 @@
                    xios(recv_field_r8_4d), xios(recv_field_r8_5d), xios(recv_field_r8_6d), xios(recv_field_r8_7d), &
                    xios(recv_field_r4_0d), xios(recv_field_r4_1d), xios(recv_field_r4_2d), xios(recv_field_r4_3d), &
-                   xios(recv_field_r4_4d), xios(recv_field_r4_5d), xios(recv_field_r4_6d), xios(recv_field_r4_7d)
+                   xios(recv_field_r4_4d), xios(recv_field_r4_5d), xios(recv_field_r4_6d), xios(recv_field_r4_7d), &
+                   xios(recv_field_r8_0d_hdl), xios(recv_field_r8_1d_hdl), xios(recv_field_r8_2d_hdl), xios(recv_field_r8_3d_hdl), &
+                   xios(recv_field_r8_4d_hdl), xios(recv_field_r8_5d_hdl), xios(recv_field_r8_6d_hdl), xios(recv_field_r8_7d_hdl), &
+                   xios(recv_field_r4_0d_hdl), xios(recv_field_r4_1d_hdl), xios(recv_field_r4_2d_hdl), xios(recv_field_r4_3d_hdl), &
+                   xios(recv_field_r4_4d_hdl), xios(recv_field_r4_5d_hdl), xios(recv_field_r4_6d_hdl), xios(recv_field_r4_7d_hdl)
 END INTERFACE xios(recv_field)
 
Index: XIOS/dev/dev_trunk_graph/src/manager/daemons_manager.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/manager/daemons_manager.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/manager/daemons_manager.hpp	(revision 2137)
@@ -1,4 +1,5 @@
 #ifndef __DAEMONS_MANAGER_HPP__
 #define __DAEMONS_MANAGER_HPP__
+#include <cstddef>
 
 namespace xios
@@ -16,6 +17,11 @@
     bool servicesEventLoop(void) ;
     
+    void scheduleContext(size_t hashId) { scheduledContext_=hashId ;} //!< for attached mode, give the hand to the associated context server
+    bool isScheduledContext(size_t hashId) { return scheduledContext_==hashId ;} //!< for attached mode, return true if context server is sceduled
+    void unscheduleContext(void) { scheduledContext_=0 ;} //!< for attached mode : unschedule context
+
     private:
     bool isServer_ ;
+    size_t scheduledContext_ = 0 ; //!< Hash id of the next scehduled context for attached mode
   } ;
 }
Index: XIOS/dev/dev_trunk_graph/src/manager/server_context.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/manager/server_context.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/manager/server_context.hpp	(revision 2137)
@@ -33,4 +33,6 @@
     void freeComm(void) ;
     bool isAttachedMode(void) { return isAttachedMode_ ;}
+    CService* getParentService(void) {return parentService_ ; }
+
     private:
     void createIntercomm(void) ;
Index: XIOS/dev/dev_trunk_graph/src/mpi_tools.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/mpi_tools.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/mpi_tools.cpp	(revision 2137)
@@ -27,3 +27,24 @@
   }
 
+  template<>
+  MPI_Datatype MPI_GetType<char>(void) { return MPI_CHAR ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<short int>(void) { return MPI_SHORT ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<int>(void) { return MPI_INT ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<size_t>(void) { return MPI_SIZE_T ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<float>(void) { return MPI_FLOAT ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<double>(void) { return MPI_DOUBLE ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<long double>(void) { return MPI_LONG_DOUBLE ;}
+
 }
Index: XIOS/dev/dev_trunk_graph/src/mpi_tools.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/mpi_tools.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/mpi_tools.hpp	(revision 2137)
@@ -13,23 +13,23 @@
 
   template<>
-  MPI_Datatype MPI_GetType<char>(void) { return MPI_CHAR ;}
+  MPI_Datatype MPI_GetType<char>(void);
 
   template<>
-  MPI_Datatype MPI_GetType<short int>(void) { return MPI_SHORT ;}
+  MPI_Datatype MPI_GetType<short int>(void);
 
   template<>
-  MPI_Datatype MPI_GetType<int>(void) { return MPI_INT ;}
+  MPI_Datatype MPI_GetType<int>(void);
 
   template<>
-  MPI_Datatype MPI_GetType<size_t>(void) { return MPI_SIZE_T ;}
+  MPI_Datatype MPI_GetType<size_t>(void);
 
   template<>
-  MPI_Datatype MPI_GetType<float>(void) { return MPI_FLOAT ;}
+  MPI_Datatype MPI_GetType<float>(void);
 
   template<>
-  MPI_Datatype MPI_GetType<double>(void) { return MPI_DOUBLE ;}
+  MPI_Datatype MPI_GetType<double>(void);
 
   template<>
-  MPI_Datatype MPI_GetType<long double>(void) { return MPI_LONG_DOUBLE ;}
+  MPI_Datatype MPI_GetType<long double>(void);
 
 
